package bus

// Channel names
const (
	WatchInvoicesChannelName  = "watch_invoices"
	WebsocketPubSubPrefix     = "websocket_update"
	UploadUpdateChannelPrefix = "upload_update"
)

// PubSub event types
const (
	PaymentReceived = iota
	SetUploadId
)

// Simple message used for update notifications in pub/sub
type Message struct {
	UploadId string      `json:"upload_id"`
	Type     int         `json:"type"` // update type
	Data     interface{} `json:"data"`
}
