package config

import (
	"fmt"

	"github.com/namsral/flag"
)

const (
	ChargeCallbackEndpoint = "chargecallback"
)

var (
	StoragePath,
	ApiPort,
	ApiInterface,
	ApiListen,
	ApiHost,
	SessionSecret,
	LnChargeApi,
	LnChargeToken,
	SqlDbHost,
	SqlDbUser,
	SqlDbPass string
)

func init() {
	// Storage
	flag.StringVar(&StoragePath, "bit4sat-storage-path", "file-storage", "base file storage path")

	// Api
	flag.StringVar(&ApiPort, "api-port", "8880", "api port number")
	flag.StringVar(&ApiInterface, "api-interface", "", "api listening interface")
	flag.StringVar(&ApiHost, "api-host", "", "reachable hostname for api (used by callbacks)")
	ApiListen = fmt.Sprintf("%s:%s", ApiInterface, ApiPort)

	flag.StringVar(&SessionSecret, "session-secret", "default-secret", "cookie sessions secret")

	// Database
	flag.StringVar(&SqlDbHost, "sql-db-host", "bit4sat", "sql db hostname")
	flag.StringVar(&SqlDbUser, "sql-db-user", "bit4sat", "sql db username")
	flag.StringVar(&SqlDbPass, "sql-db-pass", "bit4sat", "sql db pass")

	// LN Charge
	flag.StringVar(&LnChargeApi, "ln-charge-api", "", "ln charge api endpoint")
	flag.StringVar(&LnChargeToken, "ln-charge-token", "", "ln charge api token")

	flag.Parse()
}
