package storage

import "time"

type File struct {
	Name   string `form:"name"`
	SHA256 string `form:"sha256"`
	Size   int64  `form:"size"`
	Type   string `form:"type"` // MIME type
}

type UploadForm struct {
	Files []File `form:"files" binding:"required"`

	// Ask payment
	RequestPayment bool `form:"request_payment"`

	RequestPaymentAmount int `form:"request_payment_amount"`

	PaymentCurrency string `form:"payment_currency"`

	// Default Date().toJSON() from js
	TimeStamp time.Time `form:"timestamp"`
}
