import 'babel-polyfill';




const endPoints = {

    upload: '/api/upload',
    session: '/api/session',
    checkstatus: '/api/upload/check'

}



export async function lastSession(){

        let req = new Request(endPoints.session, {
            method: 'GET',
            credentials: 'same-origin'
        })

        let res = await fetch(req)
        .catch((e) => {console.error(e)})

    if (!res.ok){
        throw(`${res.status}: `  + (await res.json()).error)
    }

        return res.json()
}

export async function checkUploadStatus(uploadId){

        console.log('checking upload status')

        let req = new Request(endPoints.checkstatus + '/' + uploadId,{
            method: 'GET',
            credentials: 'same-origin,'
        })

        let res = await fetch(req)
        .catch((e) => {console.error(e)})

        
        if (!res.ok){
            let json = await res.json()
                .catch((e)=>{
                    console.error(res.text())
                })
            throw(`${res.status}: `  + json.error)
        }

        return res.json().catch((e)=>{console.error(res.text())})

}

class Upload {

    constructor(filesMetadata, fileObjects) {
        this.filesMetadata = Array.from(filesMetadata)
        this.fileObjects = fileObjects
        this.timestamp = new Date()
    }

    get uploadMetadata() {

        return {
            files: this.filesMetadata,
            timestamp: this.timestamp,
        }
    }

    async create()  {
        let req = new Request(endPoints.upload , {
            method: 'POST',
            credentials: 'same-origin',
            body: JSON.stringify(this.uploadMetadata)
        })

        //let result = await fetch(req);
        let res = await fetch(req)
        .catch((e) => { console.error(e) })


        if (!res.ok) {
            throw(`${res.status}: `  + (await res.json()).error)
        }

        return res.json().then(data => {
            let { upload_id: id  } = data
            this.uploadId = id
            return data
        })
    }

    async checkstatus(){
        return checkUploadStatus(this.uploadId)
    }

    async send(){
        console.log(`Sending with id ${this.uploadId}`)

        let formData = new FormData();
        for (let file of this.fileObjects) {
            formData.append('upload[]', file)
        }


        let req = new Request(endPoints.upload + '/' + this.uploadId, {
            method: 'PUT',
            credentials: 'same-origin',
            body: formData
        })

        let res = await fetch(req)
        .catch((e) => {console.error(e)})

        if (!res.ok){
            throw(`${res.status}: `  + (await res.json()).error)
        }

        return res.json()
    }
}

export default {
    endPoints: endPoints,
    Upload: Upload,
    checkUploadStatus: checkUploadStatus,
}
